Index: squid/src/win32.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/win32.c,v
retrieving revision 1.5
retrieving revision 1.5.14.1
diff -u -r1.5 -r1.5.14.1
--- squid/src/win32.c	18 Nov 2001 01:15:42 -0000	1.5
+++ squid/src/win32.c	14 Mar 2002 20:23:46 -0000	1.5.14.1
@@ -22,18 +22,189 @@
  *
  */
 
+#ifndef WIN32_C
+#define WIN32_C
+
 #include "squid.h"
 
 /* This code compiles only CygWin & Windows NT Port */
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
 #include <windows.h>
+#ifdef _SQUID_MSWIN_
+#if HAVE_WIN32_PSAPI
+#include <psapi.h>
+#endif
+#include <process.h>
+#endif
 
 static unsigned int GetOSVersion();
+void WIN32_svcstatusupdate(DWORD);
+void WINAPI WIN32_svcHandler(DWORD);
+static int WIN32_StoreKey(const char *, DWORD, unsigned char *, int);
+static int WIN32_create_key(void);
+static void WIN32_build_argv (char *);
+void WINAPI SquidMain(DWORD, char **);
+
+/* The following code section is part of an EXPERIMENTAL native */
+/* Windows NT/2000 Squid port - Compiles only on MS Visual C++  */
+#if defined(_SQUID_MSWIN_)
+static int Win32SockInit(void);
+static void Win32SockCleanup(void);
+#endif /* End native Windows NT EXPERIMENTAL PORT */
+
+static SERVICE_STATUS svcStatus;
+static SERVICE_STATUS_HANDLE svcHandle;
+static int WIN32_argc;
+static char ** WIN32_argv;
+static char * WIN32_module_name;
+
+#define VENDOR   "GNU"
+#if defined(_SQUID_MSWIN_)
+#define SOFTWARENAME "SquidNT"
+#else
+#define SOFTWARENAME "Squid"
+#endif
+#define WIN32_VERSION  "2.5"
+#define COMMANDLINE "CommandLine"
+#define CONFIGFILE  "ConfigFile"
+#undef ChangeServiceConfig2
+typedef BOOL (WINAPI * PFChangeServiceConfig2) (SC_HANDLE, DWORD, LPVOID);
+#ifdef UNICODE
+#define CHANGESERVICECONFIG2 "ChangeServiceConfig2W"
+#else
+#define CHANGESERVICECONFIG2 "ChangeServiceConfig2A"
+#endif
+static SC_ACTION Squid_SCAction[] = { { SC_ACTION_RESTART, 60000 } };
+static SERVICE_DESCRIPTION Squid_ServiceDescription = { SOFTWARENAME " " VERSION " WWW Proxy Server" };
+static SERVICE_FAILURE_ACTIONS Squid_ServiceFailureActions = { 0, NULL, NULL, 1, Squid_SCAction };
+static char REGKEY[256]="SOFTWARE\\"VENDOR"\\"SOFTWARENAME"\\"WIN32_VERSION"\\";
+static char *keys[] = { 
+    "SOFTWARE",	    /* key[0] */
+    VENDOR,	    /* key[1] */
+    SOFTWARENAME,   /* key[2] */
+    WIN32_VERSION,  /* key[3] */
+    NULL,	    /* key[4] */
+    NULL	    /* key[5] */
+};
 
 /* ====================================================================== */
 /* LOCAL FUNCTIONS */
 /* ====================================================================== */
 
+static int
+WIN32_create_key(void)
+{
+    int index;
+    HKEY hKey;
+    HKEY hKeyNext;
+    int retval;
+    long rv;
+
+    hKey = HKEY_LOCAL_MACHINE;
+    index = 0;
+    retval = 0;
+
+    /* Walk the tree, creating at each stage if necessary */
+    while (keys[index]) {
+	unsigned long result;
+	rv = RegCreateKeyEx(hKey, keys[index],	/* subkey */
+	    0,			/* reserved */
+	    NULL,		/* class */
+	    REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKeyNext, &result);
+	if (rv != ERROR_SUCCESS) {
+	    debug(1, 1) ("RegCreateKeyEx(%s),%d\n", keys[index], (int) rv);
+	    retval = -4;
+	}
+	/* Close the old key */
+	rv = RegCloseKey(hKey);
+	if (rv != ERROR_SUCCESS) {
+	    debug(1, 1) ("RegCloseKey %d\n", (int) rv);
+	    if (retval == 0) {
+		/* Keep error status from RegCreateKeyEx, if any */
+		retval = -4;
+	    }
+	}
+	if (retval) {
+	    break;
+	}
+	hKey = hKeyNext;
+	index++;
+    }
+    if (keys[index] == NULL) {
+	/* Close the final key we opened, if we walked the entire
+	 * tree
+	 */
+	rv = RegCloseKey(hKey);
+	if (rv != ERROR_SUCCESS) {
+	    debug(1, 1) ("RegCloseKey %d\n", (int) rv);
+	    if (retval == 0) {
+		/* Keep error status from RegCreateKeyEx, if any */
+		retval = -4;
+	    }
+	}
+    }
+    return retval;
+}
+
+static int
+WIN32_StoreKey(const char *key, DWORD type, unsigned char *value,
+    int value_size)
+{
+    long rv;
+    HKEY hKey;
+    int retval;
+
+    rv = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY, 0, KEY_WRITE, &hKey);
+    if (rv == ERROR_FILE_NOT_FOUND) {
+	/* Key could not be opened -- try to create it 
+	 */
+	if (WIN32_create_key() < 0) {
+	    /* Creation failed (error already reported) */
+	    return -4;
+	}
+	/* Now it has been created we should be able to open it
+	 */
+	rv = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY, 0, KEY_WRITE, &hKey);
+	if (rv == ERROR_FILE_NOT_FOUND) {
+	    debug(1, 1) ("Registry does not contain key %s after creation",
+		REGKEY);
+	    return -1;
+	}
+    }
+    if (rv != ERROR_SUCCESS) {
+	debug(1, 1) ("RegOpenKeyEx HKLM\\%s, %d\n", REGKEY, (int) rv);
+	return -4;
+    }
+    /* Now set the value and data */
+    rv = RegSetValueEx(hKey, key,	/* value key name */
+	0,			/* reserved */
+	type,			/* type */
+	value,			/* value data */
+	(DWORD) value_size);	/* for size of "value" */
+    retval = 0;			/* Return value */
+    if (rv != ERROR_SUCCESS) {
+	debug(1, 1) ("RegQueryValueEx(key %s),%d\n", key, (int) rv);
+	retval = -4;
+    } else {
+	debug(1, 1) ("Registry stored HKLM\\%s\\%s value %s\n",
+	    REGKEY,
+	    key,
+	    type == REG_SZ ? value : (unsigned char *) "(not displayable)");
+    }
+    /* Make sure we close the key even if there was an error storing
+     * the data
+     */
+    rv = RegCloseKey(hKey);
+    if (rv != ERROR_SUCCESS) {
+	debug(1, 1) ("RegCloseKey HKLM\\%s, %d\n", REGKEY, (int) rv);
+	if (retval == 0) {
+	    /* Keep error status from RegQueryValueEx, if any */
+	    retval = -4;
+	}
+    }
+    return retval;
+}
+
 static unsigned int
 GetOSVersion()
 {
@@ -83,24 +254,546 @@
     return _WIN_OS_UNKNOWN;
 }
 
+/* Build argv, argc from string passed from Windows.  */
+static void WIN32_build_argv(char *cmd)
+{
+    int argvlen = 0;
+    char *word;
+
+    WIN32_argc = 1;
+    WIN32_argv = (char **) xmalloc ((WIN32_argc+1) * sizeof (char *));
+    WIN32_argv[0]=xstrdup(WIN32_module_name);    
+/* Scan command line until there is nothing left. */
+    while (*cmd) {
+	/* Ignore spaces */
+	if (xisspace(*cmd)) {
+	    cmd++;
+	    continue;
+	}
+	/* Found the beginning of an argument. */
+	word = cmd;
+	while (*cmd) {
+	    cmd++;		/* Skip over this character */
+	    if (xisspace(*cmd))	/* End of argument if space */
+		break;
+	}
+	if (*cmd)
+	    *cmd++ = '\0';		/* Terminate `word' */
+	/* See if we need to allocate more space for argv */
+	if (WIN32_argc >= argvlen) {
+	    argvlen = WIN32_argc + 1;
+	    WIN32_argv = (char **) xrealloc (WIN32_argv, (1 + argvlen) * sizeof (char *));
+	}
+	/* Add word to argv file. */
+	WIN32_argv[WIN32_argc++] = word;
+    }
+    WIN32_argv[WIN32_argc] = NULL;
+}
+
 /* ====================================================================== */
 /* PUBLIC FUNCTIONS */
 /* ====================================================================== */
 
 void
+WIN32_Abort(int sig)
+{
+#ifdef USE_WIN32_SERVICE
+    svcStatus.dwWin32ExitCode = ERROR_SERVICE_SPECIFIC_ERROR;
+    svcStatus.dwServiceSpecificExitCode = 1;
+#endif
+    WIN32_Exit();
+}
+
+void
 WIN32_Exit()
 {
+#ifdef _SQUID_MSWIN_
+    Win32SockCleanup();
+#endif
+#ifdef USE_WIN32_SERVICE
+    svcStatus.dwCurrentState = SERVICE_STOPPED;
+    SetServiceStatus(svcHandle, &svcStatus);
+#endif
     _exit(0);
 }
 
-int
-WIN32_Subsystem_Init()
+#ifdef USE_WIN32_SERVICE
+int WIN32_Subsystem_Init(int * argc, char *** argv)
+#else
+int WIN32_Subsystem_Init()
+#endif
 {
     WIN32_OS_version = GetOSVersion();
     if ((WIN32_OS_version == _WIN_OS_UNKNOWN) || (WIN32_OS_version == _WIN_OS_WIN32S))
 	return 1;
     if (atexit(WIN32_Exit) != 0)
 	return 1;
+#ifdef USE_WIN32_SERVICE
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) {
+	char path[512];
+	HKEY hndKey;
+	if (signal(SIGABRT, WIN32_Abort) == SIG_ERR)
+	    return 1;
+	/* Register the service Handler function */
+	svcHandle =
+	    RegisterServiceCtrlHandler(WIN32_Service_name,
+	    WIN32_svcHandler);
+	if (svcHandle == 0)
+	    return 1;
+	/* Set Service Staus to SERVICE_START_PENDING */
+	svcStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
+	svcStatus.dwCurrentState = SERVICE_START_PENDING;
+	svcStatus.dwControlsAccepted =
+	    SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
+	svcStatus.dwWin32ExitCode = 0;
+	svcStatus.dwServiceSpecificExitCode = 0;
+	svcStatus.dwCheckPoint = 0;
+	svcStatus.dwWaitHint = 10000;
+	SetServiceStatus(svcHandle, &svcStatus);
+	/* Set Process work dir to directory cointaining squid.exe */
+	GetModuleFileName(NULL, path, 512);
+	WIN32_module_name=xstrdup(path);
+	path[strlen(path) - 10] = '\0';
+	if (SetCurrentDirectory(path) == 0)
+	    return 1;
+	safe_free(ConfigFile);
+	/* get config file from Windows Registry */
+	if (RegOpenKey(HKEY_LOCAL_MACHINE, REGKEY, &hndKey) == ERROR_SUCCESS) {
+	    DWORD Type = 0;
+	    DWORD Size = 0;
+	    LONG Result;
+	    Result =
+		RegQueryValueEx(hndKey, CONFIGFILE, NULL, &Type, NULL, &Size);
+	    if (Result == ERROR_SUCCESS && Size) {
+		ConfigFile = xmalloc(Size);
+		RegQueryValueEx(hndKey, CONFIGFILE, NULL, &Type, ConfigFile,
+		    &Size);
+	    } else
+		ConfigFile = xstrdup(DefaultConfigFile);
+	    Size = 0;
+	    Type = 0;
+	    Result =
+		RegQueryValueEx(hndKey, COMMANDLINE, NULL, &Type, NULL, &Size);
+	    if (Result == ERROR_SUCCESS && Size) {
+		WIN32_Service_Command_Line = xmalloc(Size);
+		RegQueryValueEx(hndKey, COMMANDLINE, NULL, &Type, WIN32_Service_Command_Line,
+		    &Size);
+	    } else
+		WIN32_Service_Command_Line = xstrdup("");
+	    RegCloseKey(hndKey);
+	} else {
+	    ConfigFile = xstrdup(DefaultConfigFile);
+	    WIN32_Service_Command_Line = xstrdup("");
+	}
+	WIN32_build_argv(WIN32_Service_Command_Line);
+	*argc = WIN32_argc;
+	*argv = WIN32_argv;
+    }
+#endif
+#ifdef _SQUID_MSWIN_
+    Win32SockInit();
+#endif
+    return 0;
+}
+
+#ifdef USE_WIN32_SERVICE
+void
+WIN32_svcstatusupdate(DWORD svcstate)
+{
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) {
+	svcStatus.dwCheckPoint++;
+	svcStatus.dwCurrentState = svcstate;
+	SetServiceStatus(svcHandle, &svcStatus);
+    }
+}
+
+VOID WINAPI
+WIN32_svcHandler(DWORD Opcode)
+{
+    DWORD status;
+
+    switch (Opcode) {
+    case _WIN_SQUID_SERVICE_CONTROL_STOP:
+    case _WIN_SQUID_SERVICE_CONTROL_SHUTDOWN:
+/* Do whatever it takes to stop here. */
+	svcStatus.dwWin32ExitCode = 0;
+	svcStatus.dwCurrentState = SERVICE_STOP_PENDING;
+	svcStatus.dwCheckPoint = 0;
+	svcStatus.dwWaitHint = 10000;
+	shut_down(SIGTERM);
+	if (!SetServiceStatus(svcHandle, &svcStatus)) {
+	    status = GetLastError();
+	    debug(1, 1) (" SetServiceStatus error  %ld\n", status);
+	}
+	debug(1, 1) ("Leaving Squid service \n");
+	return;
+    case _WIN_SQUID_SERVICE_CONTROL_INTERROGATE:
+/* Fall through to send current status. */
+	if (!SetServiceStatus(svcHandle, &svcStatus)) {
+	    status = GetLastError();
+	    debug(1, 1) (" SetServiceStatus error  %ld\n", status);
+	}
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_ROTATE:
+	rotate_logs(SIGUSR1);
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_RECONFIGURE:
+	reconfigure(SIGHUP);
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_DEBUG:
+	sigusr2_handle(SIGUSR2);
+	break;
+    case _WIN_SQUID_SERVICE_CONTROL_INTERRUPT:
+/* Do whatever it takes to stop here. */
+	svcStatus.dwWin32ExitCode = 0;
+	svcStatus.dwCurrentState = SERVICE_STOP_PENDING;
+	svcStatus.dwCheckPoint = 0;
+	svcStatus.dwWaitHint = 10000;
+	shut_down(SIGINT);
+	if (!SetServiceStatus(svcHandle, &svcStatus)) {
+	    status = GetLastError();
+	    debug(1, 1) (" SetServiceStatus error  %ld\n", status);
+	}
+	debug(1, 1) ("Leaving Squid service \n");
+	break;
+    default:
+	debug(1, 1) ("Unrecognized opcode %ld\n", Opcode);
+    }
+    return;
+}
+
+void
+WIN32_RemoveService()
+{
+    SC_HANDLE schService;
+    SC_HANDLE schSCManager;
+
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    strcat(REGKEY, WIN32_Service_name);
+    keys[4] = WIN32_Service_name;
+    schSCManager = OpenSCManager(NULL,	/* machine (NULL == local)    */
+	NULL,			/* database (NULL == default) */
+	SC_MANAGER_ALL_ACCESS	/* access required            */
+	);
+    if (!schSCManager)
+	debug(1, 1) ("OpenSCManager failed");
+    else {
+	schService = OpenService(schSCManager, WIN32_Service_name, SERVICE_ALL_ACCESS);
+	if (schService == NULL)
+	    debug(1, 1) ("OpenService failed");
+	/* Could not open the service */
+	else {
+	    /* try to stop the service */
+	    if (ControlService(schService, _WIN_SQUID_SERVICE_CONTROL_STOP,
+		    &svcStatus)) {
+		sleep(1);
+		while (QueryServiceStatus(schService, &svcStatus)) {
+		    if (svcStatus.dwCurrentState == SERVICE_STOP_PENDING)
+			sleep(1);
+		    else
+			break;
+		}
+	    }
+	    /* now remove the service */
+	    if (DeleteService(schService) == 0)
+		fprintf(stderr,"DeleteService failed.\n");
+	    else
+		printf("Service %s deleted successfully.\n",
+		    WIN32_Service_name);
+	    CloseServiceHandle(schService);
+	}
+	CloseServiceHandle(schSCManager);
+    }
+}
+
+void
+WIN32_SetServiceCommandLine()
+{
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    strcat(REGKEY, WIN32_Service_name);
+    keys[4] = WIN32_Service_name;
+    /* Now store the Service Command Line in the registry */
+    WIN32_StoreKey(COMMANDLINE, REG_SZ, (unsigned char *) WIN32_Command_Line, strlen(WIN32_Command_Line) + 1);
+}
+
+void
+WIN32_InstallService()
+{
+    SC_HANDLE schService;
+    SC_HANDLE schSCManager;
+    char ServicePath[512];
+    char szPath[512];
+    int lenpath;
+    
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    strcat(REGKEY, WIN32_Service_name);
+    keys[4] = WIN32_Service_name;
+    if ((lenpath = GetModuleFileName(NULL, ServicePath, 512)) == 0) {
+	debug(1, 1) ("Can't get executable path");
+	exit(1);
+    }
+    snprintf(szPath, sizeof(szPath), "%s %s:%s", ServicePath, _WIN_SQUID_SERVICE_OPTION, WIN32_Service_name);
+    schSCManager = OpenSCManager(NULL,	/* machine (NULL == local)    */
+	NULL,			/* database (NULL == default) */
+	SC_MANAGER_ALL_ACCESS	/* access required            */
+	);
+    if (!schSCManager) {    
+	debug(1, 1) ("OpenSCManager failed");
+	exit(1);
+    }
+    else {
+	schService = CreateService(schSCManager,    /* SCManager database     */
+	    WIN32_Service_name,			    /* name of service        */
+	    WIN32_Service_name,			    /* name to display        */
+	    SERVICE_ALL_ACCESS,			    /* desired access         */
+	    SERVICE_WIN32_OWN_PROCESS,		    /* service type           */
+	    SERVICE_AUTO_START,			    /* start type             */
+	    SERVICE_ERROR_NORMAL,		    /* error control type     */
+	    (const char *) szPath,		    /* service's binary       */
+	    NULL,				    /* no load ordering group */
+	    NULL,				    /* no tag identifier      */
+	    "Tcpip\0AFD\0",			    /* dependencies           */
+	    NULL,				    /* LocalSystem account    */
+	    NULL);				    /* no password            */
+	if (schService) {
+	    if ((WIN32_OS_version == _WIN_OS_WIN2K) || (WIN32_OS_version == _WIN_OS_WINXP))
+	    {
+		HMODULE ADVAPI32Handle;
+		PFChangeServiceConfig2 ChangeServiceConfig2;
+		DWORD dwInfoLevel = SERVICE_CONFIG_DESCRIPTION;
+
+		ADVAPI32Handle = GetModuleHandle("advapi32");
+		ChangeServiceConfig2 = (PFChangeServiceConfig2) GetProcAddress(ADVAPI32Handle, CHANGESERVICECONFIG2);
+		ChangeServiceConfig2(schService, dwInfoLevel, &Squid_ServiceDescription);
+		dwInfoLevel = SERVICE_CONFIG_FAILURE_ACTIONS;
+		ChangeServiceConfig2(schService, dwInfoLevel, &Squid_ServiceFailureActions);
+	    } 
+	    CloseServiceHandle(schService);
+	    /* Now store the config file location in the registry */
+	    if (!ConfigFile)
+		ConfigFile = xstrdup(DefaultConfigFile);
+	    WIN32_StoreKey(CONFIGFILE, REG_SZ, (unsigned char *) ConfigFile, strlen(ConfigFile) + 1);
+	    printf("Squid Cache version %s for %s\n", version_string,
+		CONFIG_HOST_TYPE);
+	    printf("installed successfully as %s Windows System Service.\n",
+		WIN32_Service_name);
+	    printf
+		("To run, start it from the Services Applet of Control Panel.\n");
+	    printf("Don't forget to edit squid.conf before starting it.\n\n");
+	} else {
+	    debug(1, 1) ("CreateService failed");
+	    exit(1);
+	}
+	CloseServiceHandle(schSCManager);
+    }
+}
+
+void
+WIN32_sendSignal(int WIN32_signal)
+{
+    SERVICE_STATUS ssStatus;
+    DWORD fdwAccess, fdwControl;
+    SC_HANDLE schService;
+    SC_HANDLE schSCManager;
+
+    if (!WIN32_Service_name)
+	WIN32_Service_name = xstrdup(_WIN_SQUID_DEFAULT_SERVICE_NAME);
+    schSCManager = OpenSCManager(NULL,	/* machine (NULL == local)    */
+	NULL,			/* database (NULL == default) */
+	SC_MANAGER_ALL_ACCESS	/* access required            */
+	);
+    if (!schSCManager) {
+	debug(1, 1) ("OpenSCManager failed");
+	exit(1);
+    }
+    /* The required service object access depends on the control. */
+    switch (WIN32_signal) {
+    case 0:			/* SIGNULL */
+	fdwAccess = SERVICE_INTERROGATE;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_INTERROGATE;
+	break;
+    case SIGUSR1:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_ROTATE;
+	break;
+    case SIGUSR2:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_DEBUG;
+	break;
+    case SIGHUP:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_RECONFIGURE;
+	break;
+    case SIGTERM:
+	fdwAccess = SERVICE_STOP;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_STOP;
+	break;
+    case SIGINT:
+    case SIGKILL:
+	fdwAccess = SERVICE_USER_DEFINED_CONTROL;
+	fdwControl = _WIN_SQUID_SERVICE_CONTROL_INTERRUPT;
+	break;
+    default:
+	exit(1);
+    }
+    /* Open a handle to the service. */
+    schService = OpenService(schSCManager,	/* SCManager database */
+	WIN32_Service_name,	/* name of service    */
+	fdwAccess);		/* specify access     */
+    if (schService == NULL) {
+	fprintf(stderr, "%s: ERROR: Could not open Service %s\n", appname,
+	    WIN32_Service_name);
+	exit(1);
+    } else {
+	/* Send a control value to the service. */
+	if (!ControlService(schService,	/* handle of service      */
+		fdwControl,	/* control value to send  */
+		&ssStatus)) {	/* address of status info */
+	    fprintf(stderr, "%s: ERROR: Could not Control Service %s\n",
+		appname, WIN32_Service_name);
+	    exit(1);
+	} else {
+	    /* Print the service status. */
+	    printf("\nStatus of %s Service:\n", WIN32_Service_name);
+	    printf("  Service Type: 0x%lx\n", ssStatus.dwServiceType);
+	    printf("  Current State: 0x%lx\n", ssStatus.dwCurrentState);
+	    printf("  Controls Accepted: 0x%lx\n", ssStatus.dwControlsAccepted);
+	    printf("  Exit Code: %ld\n", ssStatus.dwWin32ExitCode);
+	    printf("  Service Specific Exit Code: %ld\n",
+		ssStatus.dwServiceSpecificExitCode);
+	    printf("  Check Point: %ld\n", ssStatus.dwCheckPoint);
+	    printf("  Wait Hint: %ld\n", ssStatus.dwWaitHint);
+	}
+	CloseServiceHandle(schService);
+    }
+    CloseServiceHandle(schSCManager);
+}
+
+int main(int argc, char **argv)
+{
+    SERVICE_TABLE_ENTRY DispatchTable[] = {
+	{NULL, SquidMain},
+	{NULL, NULL}
+    };
+    char *c;
+    
+    if ((argc == 2) && strstr(argv[1], _WIN_SQUID_SERVICE_OPTION)){
+	WIN32_run_mode = _WIN_SQUID_RUN_MODE_SERVICE;
+	if (!(c=strchr(argv[1],':'))){
+	    fprintf(stderr, "Bad Service Parameter: %s\n", argv[1]);
+	    return 1;
+	}
+	WIN32_Service_name = xstrdup(c+1);
+	DispatchTable[0].lpServiceName=WIN32_Service_name;
+	strcat(REGKEY, WIN32_Service_name);
+	keys[4] = WIN32_Service_name;
+    	if (!StartServiceCtrlDispatcher(DispatchTable)) {
+	    fprintf(stderr, "StartServiceCtrlDispatcher error = %ld\n",
+		GetLastError());
+	    return 1;
+	}
+    } else {
+    	WIN32_run_mode = _WIN_SQUID_RUN_MODE_INTERACTIVE;
+	SquidMain(argc, argv);
+    }
     return 0;
 }
 #endif
+
+/* The following code section is part of an EXPERIMENTAL native */
+/* Windows NT/2000 Squid port - Compiles only on MS Visual C++  */
+
+#if defined(_SQUID_MSWIN_)
+static int s_iInitCount = 0;
+
+int WIN32_getrusage(int who, struct rusage *usage)
+{
+#if HAVE_WIN32_PSAPI
+    if ((WIN32_OS_version == _WIN_OS_WINNT) || (WIN32_OS_version == _WIN_OS_WIN2K)
+	|| (WIN32_OS_version == _WIN_OS_WINXP))
+    {
+    	/* On Windows NT/2000 call PSAPI.DLL for process Memory */
+    	/* informations -- Guido Serassio                       */
+    	HANDLE hProcess;
+    	PROCESS_MEMORY_COUNTERS pmc;
+	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
+	    PROCESS_VM_READ,
+	    FALSE, GetCurrentProcessId());
+	{
+	/* Microsoft Visual C++ doesn't have getrusage function,  */
+	/* so we get process CPU time information from PSAPI.DLL. */
+	    FILETIME ftCreate, ftExit, ftKernel, ftUser;
+	    if (GetProcessTimes(hProcess, &ftCreate, &ftExit, &ftKernel, &ftUser))
+	    {
+		LONGLONG tUser64 = (*(LONGLONG *)&ftUser / 10);
+		LONGLONG tKernel64 = (*(LONGLONG *)&ftKernel / 10);
+		usage->ru_utime.tv_sec =(long)(tUser64 / 1000000);
+		usage->ru_stime.tv_sec =(long)(tKernel64 / 1000000);
+		usage->ru_utime.tv_usec =(long)(tUser64 % 1000000);
+		usage->ru_stime.tv_usec =(long)(tKernel64 % 1000000);
+	    }
+	    else
+	    {
+		CloseHandle( hProcess );
+		return -1;
+	    }
+	}
+	if (GetProcessMemoryInfo( hProcess, &pmc, sizeof(pmc)))
+	{
+	    usage->ru_maxrss=(DWORD)(pmc.WorkingSetSize /1024);
+	    usage->ru_majflt=pmc.PageFaultCount;
+	}
+	else
+	{
+	    CloseHandle( hProcess );
+	    return -1;
+	}
+	CloseHandle( hProcess );
+    }
+#endif
+    return 0;
+}
+
+static int Win32SockInit(void)
+{
+    int iVersionRequested;
+    WSADATA wsaData;
+    int err;
+
+    if (s_iInitCount > 0) {
+	s_iInitCount++;
+	return (0);
+    }
+    else if (s_iInitCount < 0)
+	return (s_iInitCount);
+    /* s_iInitCount == 0. Do the initailization */
+    iVersionRequested = MAKEWORD(2, 0);
+    err = WSAStartup((WORD) iVersionRequested, &wsaData);
+    if (err) {
+	s_iInitCount = -1;
+	return (s_iInitCount);
+    }
+    if (LOBYTE(wsaData.wVersion) != 2 ||
+	HIBYTE(wsaData.wVersion) != 0) {
+	s_iInitCount = -2;
+	WSACleanup();
+	return (s_iInitCount);
+    }
+    debug(1,1)("Windows sockets initialised");
+    s_iInitCount++;
+    return (s_iInitCount);
+}
+
+static void Win32SockCleanup(void)
+{
+    if (--s_iInitCount == 0)
+	WSACleanup();
+    return;
+}
+#endif /* End native Windows NT EXPERIMENTAL PORT */
+#endif
+
+#endif /* WIN32_C */
--- /dev/null	Wed Feb 14 00:55:47 2007
+++ squid/src/fs/awin32/Makefile	Wed Feb 14 00:57:26 2007
@@ -0,0 +1,241 @@
+# Makefile.in generated automatically by automake 1.5 from Makefile.am.
+
+# Copyright 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
+# Free Software Foundation, Inc.
+# This Makefile.in is free software; the Free Software Foundation
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
+# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
+# PARTICULAR PURPOSE.
+
+
+
+SHELL = /bin/sh
+
+srcdir = .
+top_srcdir = ../../..
+
+prefix = c:/squid
+exec_prefix = ${prefix}
+
+bindir = ${exec_prefix}/bin
+sbindir = ${exec_prefix}/sbin
+libexecdir = ${exec_prefix}/libexec
+datadir = ${prefix}/share
+sysconfdir = ${prefix}/etc
+sharedstatedir = ${prefix}/com
+localstatedir = ${prefix}/var
+libdir = ${exec_prefix}/lib
+infodir = ${prefix}/info
+mandir = ${prefix}/man
+includedir = ${prefix}/include
+oldincludedir = /usr/include
+pkgdatadir = $(datadir)/squid
+pkglibdir = $(libdir)/squid
+pkgincludedir = $(includedir)/squid
+top_builddir = ../../..
+
+ACLOCAL = ${SHELL} /cygdrive/c/work/cygwin-svc/cfgaux/missing --run aclocal
+AUTOCONF = ${SHELL} /cygdrive/c/work/cygwin-svc/cfgaux/missing --run autoconf
+AUTOMAKE = ${SHELL} /cygdrive/c/work/cygwin-svc/cfgaux/missing --run automake
+AUTOHEADER = ${SHELL} /cygdrive/c/work/cygwin-svc/cfgaux/missing --run autoheader
+
+INSTALL = /usr/bin/install -c
+INSTALL_PROGRAM = ${INSTALL}
+INSTALL_DATA = ${INSTALL} -m 644
+INSTALL_SCRIPT = ${INSTALL}
+INSTALL_HEADER = $(INSTALL_DATA)
+transform = s,x,x,
+NORMAL_INSTALL = :
+PRE_INSTALL = :
+POST_INSTALL = :
+NORMAL_UNINSTALL = :
+PRE_UNINSTALL = :
+POST_UNINSTALL = :
+host_alias = 
+host_triplet = i686-pc-cygwin
+AIOLIB = 
+AMTAR = ${SHELL} /cygdrive/c/work/cygwin-svc/cfgaux/missing --run tar
+AR = /usr/bin/ar
+AR_R = /usr/bin/ar r
+AUTH_LIBS = libbasic.a libntlm.a
+AUTH_MODULES = basic ntlm
+AUTH_OBJS = auth/libbasic.a auth/libntlm.a
+AWK = gawk
+BASIC_AUTH_HELPERS = win32_locallogon
+CC = gcc
+CPP = gcc -E
+CRYPTLIB = -lcrypt
+CXX = @CXX@
+DEPDIR = .deps
+DIGEST_AUTH_HELPERS = 
+DLLIB = 
+ERR_DEFAULT_LANGUAGE = English
+ERR_LANGUAGES =  Bulgarian Czech Danish Dutch English Estonian Finnish French German Hungarian Italian Japanese Korean Polish Portuguese Romanian Russian-1251 Russian-koi8-r Serbian Simplify_Chinese Slovak Spanish Swedish Traditional_Chinese Turkish
+EXEEXT = .exe
+FALSE = /usr/bin/false
+INSTALL_STRIP_PROGRAM = ${SHELL} $(install_sh) -c -s
+LIBDLMALLOC = 
+LIBREGEX = 
+LIB_MALLOC = 
+LN = /usr/bin/ln
+LN_S = ln -s
+MAINT = #
+MKDIR = /usr/bin/mkdir
+MV = /usr/bin/mv
+NTLM_AUTH_HELPERS = NTLMSSP
+OBJEXT = o
+OPT_DISKD_EXE = 
+OPT_DNSSERVER_EXE = 
+OPT_PINGER = 
+OPT_PINGER_EXE = 
+PACKAGE = squid
+PERL = /usr/bin/perl
+PTHREADLIB = -lpthread
+RANLIB = ranlib
+REGEXLIB = -lregex
+REPL_LIBS = liblru.a
+REPL_OBJS = repl/liblru.a
+REPL_POLICIES = lru
+RM = /usr/bin/rm
+SH = /usr/bin/sh
+SNMPLIB = -L../snmplib -lsnmp
+SQUID_AIO_LIB = 
+SQUID_PTHREAD_LIB = 
+SSLLIB = 
+STORE_LIBS = libufs.a
+STORE_MODULES = ufs
+STORE_MODULE_SUBDIRS = 
+STORE_OBJS = fs/libufs.a
+TRUE = /usr/bin/true
+VERSION = 2.6-DEVEL
+XTRA_LIBS = -lm
+XTRA_OBJS = 
+am__include = include
+am__quote = 
+install_sh = /cygdrive/c/work/cygwin-svc/cfgaux/install-sh
+makesnmplib = snmplib
+subdir = src/fs/awin32
+mkinstalldirs = $(SHELL) $(top_srcdir)/cfgaux/mkinstalldirs
+CONFIG_HEADER = $(top_builddir)/include/autoconf.h
+CONFIG_CLEAN_FILES =
+DIST_SOURCES =
+DIST_COMMON = Makefile.am Makefile.in
+all: all-am
+
+.SUFFIXES:
+$(srcdir)/Makefile.in: # Makefile.am  $(top_srcdir)/configure.in $(ACLOCAL_M4)
+	cd $(top_srcdir) && \
+	  $(AUTOMAKE) --foreign  src/fs/awin32/Makefile
+Makefile: # $(srcdir)/Makefile.in  $(top_builddir)/config.status
+	cd $(top_builddir) && \
+	  CONFIG_HEADERS= CONFIG_LINKS= \
+	  CONFIG_FILES=$(subdir)/$@ $(SHELL) ./config.status
+uninstall-info-am:
+tags: TAGS
+TAGS:
+
+
+DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
+
+top_distdir = ../../..
+distdir = $(top_distdir)/$(PACKAGE)-$(VERSION)
+
+distdir: $(DISTFILES)
+	@for file in $(DISTFILES); do \
+	  if test -f $$file; then d=.; else d=$(srcdir); fi; \
+	  dir=`echo "$$file" | sed -e 's,/[^/]*$$,,'`; \
+	  if test "$$dir" != "$$file" && test "$$dir" != "."; then \
+	    $(mkinstalldirs) "$(distdir)/$$dir"; \
+	  fi; \
+	  if test -d $$d/$$file; then \
+	    cp -pR $$d/$$file $(distdir) \
+	    || exit 1; \
+	  else \
+	    test -f $(distdir)/$$file \
+	    || cp -p $$d/$$file $(distdir)/$$file \
+	    || exit 1; \
+	  fi; \
+	done
+check-am: all-am
+check: check-am
+all-am: Makefile
+
+installdirs:
+
+install: install-am
+install-exec: install-exec-am
+install-data: install-data-am
+uninstall: uninstall-am
+
+install-am: all-am
+	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
+
+installcheck: installcheck-am
+install-strip:
+	$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
+	  `test -z '$(STRIP)' || \
+	    echo "INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'"` install
+mostlyclean-generic:
+
+clean-generic:
+
+distclean-generic:
+	-rm -f Makefile $(CONFIG_CLEAN_FILES) stamp-h stamp-h[0-9]*
+
+maintainer-clean-generic:
+	@echo "This command is intended for maintainers to use"
+	@echo "it deletes files that may require special tools to rebuild."
+clean: clean-am
+
+clean-am: clean-generic mostlyclean-am
+
+distclean: distclean-am
+
+distclean-am: clean-am distclean-generic
+
+dvi: dvi-am
+
+dvi-am:
+
+info: info-am
+
+info-am:
+
+install-data-am:
+
+install-exec-am:
+
+install-info: install-info-am
+
+install-man:
+
+installcheck-am:
+
+maintainer-clean: maintainer-clean-am
+
+maintainer-clean-am: distclean-am maintainer-clean-generic
+
+mostlyclean: mostlyclean-am
+
+mostlyclean-am: mostlyclean-generic
+
+uninstall-am: uninstall-info-am
+
+.PHONY: all all-am check check-am clean clean-generic distclean \
+	distclean-generic distdir dvi dvi-am info info-am install \
+	install-am install-data install-data-am install-exec \
+	install-exec-am install-info install-info-am install-man \
+	install-strip installcheck installcheck-am installdirs \
+	maintainer-clean maintainer-clean-generic mostlyclean \
+	mostlyclean-generic uninstall uninstall-am uninstall-info-am
+
+
+all clean:
+	@cd .. && $(MAKE) $(MFLAGS) awin32/$@
+# Tell versions [3.59,3.63) of GNU make to not export all variables.
+# Otherwise a system limit (for SysV at least) may be exceeded.
+.NOEXPORT:
--- /dev/null	Wed Feb 14 00:55:47 2007
+++ squid/src/fs/awin32/Makefile.am	Wed Feb 14 00:57:26 2007
@@ -0,0 +1,2 @@
+all clean:
+	@cd .. && $(MAKE) $(MFLAGS) awin32/$@
